#include "example1.h"
#include <stdlib.h>
#include <stdio.h>
#include <pthread.h>
#include <time.h>

/*inciando un mutex para proteger las variables globales
 */
pthread_mutex_t shared_mutex = PTHREAD_MUTEX_INITIALIZER;

void exBinarySearch()
{
    int a[10];
    int i;
    void *found;
    
    srand ( time(NULL) );
    
    printf("\na[]=");
    for ( i = 0; i < 10; i++)
    {    
        /*generando un arreglo al azar 0-20*/ 
        a[i] = rand()%21;
        printf("%d,",a[i]);
    }    
    printf("\n");
    
    
    /* Creo una estructura donde almacenaremos
     * los valores de los parametros que seran
     * usados en la funcion
     */
    VariablesVersion1 variables;
    variables.a = a;
    variables.i = 0;
    variables.j = 9;
    variables.x = 2;
    
    /* Buscando el elemento 2*/
    printf("\n Buscando sin limites");
    found = searchBinaryArrayParalize((void *)&variables);
    isFound(found,variables.x);
    
    /* Buscando el elemento 20
     Por que no es necesario crear otra instancia de la estructura?*/
    variables.x = 20;
    found = searchBinaryArrayParalize((void *)&variables);
    
    /*Busca si esta el elemento */
    isFound(found,variables.x);
    
    /*
     *Creando una estructura distinta para meter la limitidad de nivel
     */
    VariablesVersion2 variables2;
    variables2.a = a;
    variables2.i = 0;
    variables2.j = 9;
    variables2.x = 2;
    variables2.level = 6;
    
    /* Buscando el elemento 2 con la nueva funcion*/
    printf("\n Buscando con limites de level");
    found = searchBinaryArrayParalize2((void *)&variables2);
    isFound(found,variables2.x);
    
    /* Buscando el elemento 20 con la nueva funcion*/
    variables2.x = 20;
    found = searchBinaryArrayParalize2((void *)&variables2);
    isFound(found,variables2.x);
   
    /*
     *Creando una estructura distinta para meter la limitidad de nivel
     */
    VariablesVersion2 variables3;
    variables3.a = a;
    variables3.i = 0;
    variables3.j = 9;
    variables3.x = 2;
    variables3.level = 6;
    
    /* Ahora usamos foundGlobal, con la direccion del elemento
     * sabremos si esta el elemento */
    foundGlobal = NULL;
    
    /*Buscando el elemento en con level y found en la nueva funcion */
    printf("\n Buscando con limites de found y level");
    found = searchBinaryArrayParalize3((void *)&variables3);
    isFound(foundGlobal,variables3.x);
    
    variables3.x = 20;
    foundGlobal = NULL;
    found = searchBinaryArrayParalize3((void *)&variables3);
    isFound(foundGlobal,variables3.x);
    
    
    variables3.a = a;
    variables3.i = 0;
    variables3.j = 9;
    variables3.x = 2;
    variables3.level = 6;
    foundGlobal = NULL;
    numberTimes = 0;
    
    printf("\n Buscando con limites de found y level y contando");
    found = searchBinaryArrayParalize4((void *)&variables3);
    isFound(foundGlobal,variables3.x);
    printf("\nEntro a la funcion %d veces\n",numberTimes);
    
    variables3.x = 20;
    foundGlobal = NULL;
    numberTimes = 0;
    found = searchBinaryArrayParalize4((void *)&variables3);
    isFound(foundGlobal,variables3.x);
    printf("\nEntro a la funcion %d veces\n",numberTimes);
    
    /* destruyendo lo usado*/ 
    pthread_mutex_destroy(&shared_mutex);
}

void *searchBinaryArrayParalize(void *vArgument)
{
    /*Dos hilos para buscar ambas partes del arreglo */
    pthread_t t1;
    pthread_t t2;
    
    /*Variables para tener la respuesta de los hilos */
    void *rest1;
    void *rest2;
    VariablesVersion1 *vx;
    
    /* Transformando el valor de entrada */
    vx = (VariablesVersion1 *) vArgument;
    
    /*el elemento medio*/
    int k = (vx->i+vx->j)/2;
    
    /*
    printf("\nANTES: Variables del hilo actual \n");
    printf("\n a[k],i,j,x=(%d,%d,%d,%d)\n",vx->a[k],vx->i,vx->j,vx->x);
    */
    
    
    /* Caso: Por que debe haber este caso y que significa?*/
    if (vx->i > vx->j) 
          return NULL;
    else 
         /* si el elemento esta */
         if(vx->a[k] == vx->x) 
         /* devuelve la direccionde memoria*/    
         return (void *) &(vx->a[k]);
    else
    {
        /* dos estructuras para argumento de funciones*/
        VariablesVersion1 v1;
        VariablesVersion1 v2;
        
        /* creando los argumentos*/
        
        /* comparten el arreglo*/
        /* por que no se protege el arreglo*/
        v1.a = v2.a = vx->a;
        v1.x = v2.x = vx->x;
        v1.i = vx->i;
        v1.j = k - 1;
        v2.i = k + 1;
        v2.j = vx->j;
        
        
        /* creando los dos hilos*/
        pthread_create(&t1,NULL,searchBinaryArrayParalize,(void *) &v1);
        pthread_create(&t2,NULL,searchBinaryArrayParalize,(void *) &v2);
                               
        /* esperando a los hilos y sus respuesto*/
 	pthread_join(t1,&rest1);
        pthread_join(t2,&rest2);
        
        /*
        printf("\n Variables del hilo actual \n");
        printf("\na[k],i,j,x=(%d,%d,%d,%d)\n",vx->a[k],vx->i,vx->j,vx->x);
                
        printf("\nHilo rest1 %p\n",rest1);
        printf("\nHilo rest2 %p\n",rest2);
        */
        
         /* como funciona el return de esta funcion para 
          * encontrar el elemento?
          */
         return ((void *)(rest1 || rest2));
    }	
	 	
    	
}


/*
 * Ahora con limite de en la creacion de arbol
 */
void *searchBinaryArrayParalize2(void *vArgument)
{
    pthread_t t1;
    pthread_t t2;
    
    void *rest1;
    void *rest2;
    VariablesVersion2 *vx;
    
    vx = (VariablesVersion2 *) vArgument;
    
    int k = (vx->i+vx->j)/2;
    
    /*
    printf("\nANTES: Variables del hilo actual \n");
    printf("\n a[k],i,j,x=(%d,%d,%d,%d)\n",vx->a[k],vx->i,vx->j,vx->x);
    */
    
    if (vx->i > vx->j) 
          return NULL;
    else if(vx->a[k] == vx->x) 
         return (void *) &(vx->a[k]);
    else
    {
        /* creando estructuras que soporte un parametro mas*/
        VariablesVersion2 v1;
        VariablesVersion2 v2;
        
        /* inicializando los valores*/
        v1.a = v2.a = vx->a;
        v1.x = v2.x = vx->x;
        v1.i = vx->i;
        v1.j = k - 1;
        v2.i = k + 1;
        v2.j = vx->j;
        v1.level = v2.level = vx->level--;
        
        
        /* todavia se pueden crear hilos*/
        if (vx->level > 0)
        {
            pthread_create(&t1,NULL,searchBinaryArrayParalize2,(void *) &v1);
            pthread_create(&t2,NULL,searchBinaryArrayParalize2,(void *) &v2);
                               
            pthread_join(t1,&rest1);
            pthread_join(t2,&rest2);
        }    
        else
        {
            /* Ahora solamente secuencial*/
            rest1 = searchBinaryArrayParalize2((void *) &v1);
            rest2 = searchBinaryArrayParalize2((void *) &v2);
        }    
        
        /*
        printf("\n Variables del hilo actual \n");
        printf("\na[k],i,j,x=(%d,%d,%d,%d)\n",vx->a[k],vx->i,vx->j,vx->x);
                
        printf("\nHilo rest1 %p\n",rest1);
        printf("\nHilo rest2 %p\n",rest2);
        */
        
         return ((void *)(rest1 || rest2));
    }	
	 	
    	
}

/* Ahora con found para notificar quien encontro el elemento*/
void *searchBinaryArrayParalize3(void *vArgument)
{
    pthread_t t1;
    pthread_t t2;
    
    void *rest1;
    void *rest2;
    VariablesVersion2 *vx;
    
    vx = (VariablesVersion2 *) vArgument;
    
    int k = (vx->i+vx->j)/2;
    
    /* 
    printf("\nANTES: Variables del hilo actual ");
    printf("\n a[k],i,j,x,found=(%d,%d,%d,%d,%p)\n",
             vx->a[k],vx->i,vx->j,vx->x,foundGlobal);
    */
    
    
    /* caso base crecio: ya fue encontrado (foundGlobal) */
    if (vx->i > vx->j || foundGlobal != NULL) 
          return NULL;
    else 
    if(vx->a[k] == vx->x) 
    {
        /* si lo encontramos almacenamos su direccion */
        /* por que no protegemos foundGlobal?*/
        foundGlobal = &(vx->a[k]);
        return (void *) &(vx->a[k]);
    }     
    else
    {
        VariablesVersion2 v1;
        VariablesVersion2 v2;
        
        v1.a = v2.a = vx->a;
        v1.x = v2.x = vx->x;
        v1.i = vx->i;
        v1.j = k - 1;
        v2.i = k + 1;
        v2.j = vx->j;
        v1.level = v2.level = vx->level--;
                
        if (vx->level > 0)
        {
            pthread_create(&t1,NULL,searchBinaryArrayParalize3,(void *) &v1);
            pthread_create(&t2,NULL,searchBinaryArrayParalize3,(void *) &v2);
                               
            pthread_join(t1,&rest1);
            pthread_join(t2,&rest2);
        }    
        else
        {
            rest1 = searchBinaryArrayParalize3((void *) &v1);
            rest2 = searchBinaryArrayParalize3((void *) &v2);
        }    
        
        /*
        printf("\n Despues Variables del hilo actual");
        printf("\na[k],i,j,x,found=(%d,%d,%d,%d,%p)\n",
         vx->a[k],vx->i,vx->j,vx->x,foundGlobal);
                
        printf("\nHilo rest1 %p\n",rest1);
        printf("\nHilo rest2 %p\n",rest2);
        */
        
        /* Ahora sirve el valor de retorno?*/
        return ((void *)(rest1 || rest2));
    }	
	 	
    	
}

/* ahora contando cuantas veces entramos en la funcion*/
void *searchBinaryArrayParalize4(void *vArgument)
{
    /*protegiendo con el mutex*/
    pthread_mutex_lock(&shared_mutex);
    numberTimes++;
    pthread_mutex_unlock(&shared_mutex);
    
    pthread_t t1;
    pthread_t t2;
    
    void *rest1;
    void *rest2;
    VariablesVersion2 *vx;
    
    vx = (VariablesVersion2 *) vArgument;
    
    int k = (vx->i+vx->j)/2;
    
    /* 
    printf("\nANTES: Variables del hilo actual ");
    printf("\n a[k],i,j,x,found=(%d,%d,%d,%d,%p)\n",
             vx->a[k],vx->i,vx->j,vx->x,foundGlobal);
    */
    
    
    if (vx->i > vx->j || foundGlobal != NULL) 
          return NULL;
    else 
    if(vx->a[k] == vx->x) 
    {
        foundGlobal = &(vx->a[k]);
        return (void *) &(vx->a[k]);
    }     
    else
    {
        VariablesVersion2 v1;
        VariablesVersion2 v2;
        
        v1.a = v2.a = vx->a;
        v1.x = v2.x = vx->x;
        v1.i = vx->i;
        v1.j = k - 1;
        v2.i = k + 1;
        v2.j = vx->j;
        v1.level = v2.level = vx->level--;
                
        if (vx->level > 0)
        {
            pthread_create(&t1,NULL,searchBinaryArrayParalize4,(void *) &v1);
            pthread_create(&t2,NULL,searchBinaryArrayParalize4,(void *) &v2);
                               
            pthread_join(t1,&rest1);
            pthread_join(t2,&rest2);
        }    
        else
        {
            rest1 = searchBinaryArrayParalize4((void *) &v1);
            rest2 = searchBinaryArrayParalize4((void *) &v2);
        }    
        
        /*
        printf("\n Despues Variables del hilo actual");
        printf("\na[k],i,j,x,found=(%d,%d,%d,%d,%p)\n",
         vx->a[k],vx->i,vx->j,vx->x,foundGlobal);
                
        printf("\nHilo rest1 %p\n",rest1);
        printf("\nHilo rest2 %p\n",rest2);
        */
        
         return ((void *)(rest1 || rest2));
    }	
	 	
    	
}

/* funcion solamente dice si un elemento fue encontrado*/
void isFound(void *found, int element)
{
     if (found)
        printf("\nEl elemento %d SI fue encontrado\n",element);
    else
        printf("\nEl elemento %d No fue encontrado\n",element);
}
