#include"07_monitor.h"
#include"example2.h"
#include<pthread.h>
#include<time.h>
#include<stdlib.h>
#include<stdio.h>


pthread_mutex_t shared_mutex2 = PTHREAD_MUTEX_INITIALIZER;

/* Creando un monitor*/
/* Para que es y como se ocupa */
Monitor *mon;

void exSimulation()
{
    numberOperations = 0;
    mon = createMonitor();
    
    pthread_t push;
    pthread_t extrac;
    
    List *l = makeList();
    
    /* creando hilos que crean y ponen elemento en la lista*/
    pthread_create(&extrac,NULL,extracter,(void *)l);
    pthread_create(&push,NULL,pusher,(void *) l);
    
    /* esperando a estos hilos*/
    pthread_join(push,NULL);
    pthread_join(extrac,NULL);
    
    destroyMonitor(mon);
    pthread_mutex_destroy(&shared_mutex2);
    
    printf("\nTermino Ejecutar\n");
    
}

/*  El pusher tiene una firma  */
void *pusher(void *lx)
{
    
    List *l = (List *) lx;
    
    /* para que use srand */
    /*srand ( time(NULL) );*/
     
    
     Node *aux;
    
    while (numberOperations < MAX)
    {    
        sleep(2);
        
        aux = makeNode(numberOperations);
        printf("\nElemento ingresado de la lista es %d\n",aux->val);
        
        /* ingresando un elemento*/
        pushList(l,aux);
            
        pthread_mutex_lock(&shared_mutex2);
        numberOperations++;
        pthread_mutex_unlock(&shared_mutex2);
    }    
    
      /* este valor sirve de algo?*/
     return NULL;
}

void *extracter(void *lx)
{
    Node *aux;
    List *l = (List *) lx;
    
    while (numberOperations < MAX)
    {    
        
        /* sacando el elemento*/
        aux = extractList(l);
        printf("\nElemento sacado de la lista es %d\n",aux->val);
        
    
        pthread_mutex_lock(&shared_mutex2);
        numberOperations++;
        pthread_mutex_unlock(&shared_mutex2);
        
    }    
    
    return NULL;
}

/* creando lista. Con cuantos elementos empieza la lista*/
List *makeList()
{
    List *list = (List *) malloc(sizeof(List));
    
    list->first = list->last = NULL;
    return list;
}


/* creando un nodo */
Node *makeNode(int val)
{
    Node *node = (Node *) malloc(sizeof(Node));
    
    node->val = val;
    node->next = NULL;
    return node;
}

/* agregando un elemento a la lista*/
/* por que esta funcion no tiene la funcion wait del monitor*/
void pushList(List *l,Node *n)
{
    /* tomando el monitor*/
    monitorEnter(mon);
    
    /* si es vacia la lista */
    if (l->last == NULL)
    {
        l->first = l->last = n;
    }    
    else
    {    
        /* actualizando la lista */
        l->last->next = n;
        l->last = n;
    }   
    
    /* notificando para despestar a los esperaba por un elemento*/
    monitorNotifyWaiting(mon);
    
    /* soltando el elemento*/
    monitorExit(mon);
}

/* extrayendo un elemento*/
Node *extractList(List *l)
{
    /* tomando el monitor*/
    monitorEnter(mon);

    /* verificando si hay elemento en la lista*/
    /* si no hay tenemos que dormir*/
    /* por que while y no if*/
    while (l->first == NULL)
        monitorWaitOn(mon);
   
    /* sacando el primero*/
    Node *aux = l->first;
    l->first = l->first->next;
    
    if (l->first == NULL)
        l->last = NULL;
    
    monitorExit(mon);
    
    return aux;
}
