#include"example3.h"
#include"07_monitor.h"
#include<pthread.h>
#include<time.h>
#include<stdlib.h>
#include<stdio.h>


pthread_mutex_t shared_mutex3 = PTHREAD_MUTEX_INITIALIZER;


Monitor *mon3;
int cicle = 0;

void exReaderWriter()
{
    srand ( time(NULL) );
    reader = writer = 0; 
    tryReader = tryWriter = 0;
    mon3 = createMonitor();
    
    pthread_t tReader;
    pthread_t tWriter;
            
    pthread_create(&tReader,NULL,processReader,NULL);
    pthread_create(&tWriter,NULL,processWriter,NULL);
    
    pthread_join(tReader,NULL);
    pthread_join(tWriter,NULL);
    
    /*destruyendo lo utilizado */
    destroyMonitor(mon3);
    pthread_mutex_destroy(&shared_mutex3);
    
    printf("\nTermino Ejecutar\n");
    
}

/* controlando la entrada de lectores*/
/* pueden entrar varios lectores*/
void enterRead()
{
  monitorEnter(mon3);

  /* dormir si hay un escritor*/
   while (writer > 0)
        monitorWaitOn(mon3);
   
    /* incrementar escritor*/
    reader++;
    
    monitorExit(mon3);
}

void enterWrite()
{
    monitorEnter(mon3);

    /* dormir si hay alguno escritor o lector*/
    /* por que no &&?*/
    while (reader > 0 || writer > 0)
        monitorWaitOn(mon3);
    
    /*incrementando ... 
     Esta variable esta protegida o no?*/
    writer++;
    
    monitorExit(mon3);
}

void read()
{
    /* un proceso costoso*/
    sleep(rand()%2);
    printf("\n READER: Writers:%d Readers:%d Op:%d",writer,reader,cicle);
   
}
void write()
{
    /* un proceso costoso*/
    sleep(rand()%3);
    printf("\n WRITER: Writers:%d Readers:%d Op:%d",writer,reader,cicle);
}

void exitRead()
{
    /* para que tomo el monitor*/
    monitorEnter(mon3);
    reader--;
    
    /*  A quien estoy desperatando aca?*/
    if (reader == 0)
        monitorNotifyWaiting(mon3);
    
    monitorExit(mon3);
}

void exitWrite()
{
    monitorEnter(mon3);
    writer--;
    
    /*  A quien estoy desperatando aca?*/
    /* solamente escritores ...?*/
    if (writer == 0)
        monitorNotifyWaiting(mon3);
    
    monitorExit(mon3);
}
 
/* Proceso que agrega lectores... en la base de datos*/
/* cada lector es un hilo independiente (un actor con voluntad)*/
void *processReader(void *val)
{
    
    /*caso base de la funcion recursiva */
    if (cicle < MAXOPERATIONS)
    {
        /* por que aca protego con un mutex las variables y no con monitor?*/
        pthread_mutex_lock(&shared_mutex3);
        cicle++;
        tryReader++;
        pthread_mutex_unlock(&shared_mutex3);
        
        printf("\n TRYREADER: TWriters:%d TReaders:%d Op:%d",tryWriter,tryReader,cicle);
        
        sleep(rand()%2);
        
        /* creo un hilo que sera un lector*/
        pthread_t aux;
        
        /* llamo al proceso de leer*/
        pthread_create(&aux,NULL,addReader,NULL);
        
        /* Vuelvo a llamar a la misma funcion*/
        /* que logro con esto?*/
        processReader(NULL);
        
        /* hay que logro entrar a la bd no es un intento*/
        pthread_mutex_lock(&shared_mutex3);
        tryReader--;
        pthread_mutex_unlock(&shared_mutex3);
        
        /*ahora espero */
        pthread_join(aux,NULL);
    }
    
    return NULL;
}

/* Proceso que agrega escritores... en la base de datos*/
/* cada escritor es un hilo independiente (un actor con voluntad)*/
void *processWriter(void *val)
{

    /* caso base de la funcion recursiva*/
    if (cicle < MAXOPERATIONS)
    {
        
        /* protegiendo estas varaibles */
        pthread_mutex_lock(&shared_mutex3);
        cicle++;
        tryWriter++;
        pthread_mutex_unlock(&shared_mutex3);
        
        printf("\n TRYWriter: TWriters:%d TReaders:%d Op:%d",tryWriter,tryReader,cicle);
        
        sleep(rand()%1);
        
        pthread_t aux;
        
        pthread_create(&aux,NULL,addWriter,NULL);
        processWriter(NULL);
        
        pthread_mutex_lock(&shared_mutex3);
        tryWriter--;
        pthread_mutex_unlock(&shared_mutex3);
        
        pthread_join(aux,NULL);
    }
    
    return NULL;
}


/* el proceso de leer*/
void* addReader(void *val)
{
    /* enter y exit son procesos protegidos por el monitor
     * son poco concurrentes estos metodos, por eso 
     * deben ser ligeros y rapidos
     * el proceso read o write no es protegido y por eso permite concurrencia
     * ademas es un proceso costoso
     */
    enterRead();
    read();
    exitRead();
    
    return NULL;
}

/* el proceso de escribir*/
void* addWriter(void *val)
{
    /* enter y exit son procesos protegidos por el monitor
     * son poco concurrentes estos metodos, por eso 
     * deben ser ligeros y rapidos
     * el proceso read o write no es protegido y por eso permite concurrencia
     * ademas es un proceso costoso
     */
    enterWrite();
    write();
    exitWrite();
 
    return NULL;
}
